pub mod passwd_fields;
pub mod shadow_fields;
/// A record(line) in the user database `/etc/passwd` found in most linux systems.
#[derive(Debug, PartialEq, Eq)]
pub struct User<'a> {
    source: &'a str,
    username: crate::Username<'a>,    /* Username.  */
    password: crate::Password<'a>, /* Hashed passphrase, if shadow database not in use (see shadow.h).  */
    uid: crate::Uid,               /* User ID.  */
    gid: crate::Gid,               /* Group ID.  */
    gecos: crate::Gecos<'a>,       /* Real name.  */
    home_dir: crate::HomeDir<'a>,  /* Home directory.  */
    shell_path: crate::ShellPath<'a>, /* Shell program.  */
}
